Subject: Re: bug#34949: 27.0.50; Docstring of `vc-deduce-fileset' incomplete

From: Dmitry Gutov <[email-masked]>
Date: Mon, 30 Mar 2020 23:01:35 +0300

On 30.03.2020 01:27, Juri Linkov wrote:
>>>> However! vc-dir-mark-all-files has a special behavior when it's called with
>>>> C-u: it tries to mark all files in the current VC-Dir buffer.
>>> Or equivalent behavior is when typing 'M' at the top of VC-Dir buffer.
>>
>> Not exactly: here it only marks the files in the same state as the first
>> file in the buffer.
> 
> Right, it affects only the files in the root directory.

Ah, right. Indeed.

>> I really think we should optimize for the most frequent operation
>> there. Otherwise, 'C-u M' remains fairly useless (but still takes up a key
>> sequence). The fact that it can mark a set of files in incompatible
>> statuses, and nobody has filed a bug report about that until now, likely
>> indicates that people don't often use it. Or don't use it at all.
> 
> Actually, marking all files with 'C-u M' is not useless.  There are
> other VC commands that make sense to run on all marked files, e.g.
> search in all files marked by 'C-u M', query-replace, delete, etc.

Hmm, you might be right. If we're sure that people do take advantage of 
that, let's keep it.

We could tweak it a little, though. Like:

           M -> mark all files in the same status
       C-u M -> mark all registered files
   C-u C-u M -> mark all files in the vc-dir buffer

Or bind vc-dir-mark-registered to a new char indeed, e.g. 'r'.